<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibsT3.jsp" %>
<style type="text/css">@import "common/styles/cf.css";</style>

<script language="JavaScript" src="admin/scripts/strategyTreeActions.js"></script>

<!-- Tree header. -->
<%-- <div id="navhead" class="mmhide_navhd" ><fmt:message key="fcm.sq.strategy.allStrategies.txt"/>&nbsp;</div> --%>
<div class="sapUiTreeHeader" id="strategiesHeader" role="heading">
  <div class="sapUiTreeTitle"><fmt:message key="fcm.sq.strategy.allStrategies.txt"/></div>
</div>

<!-- Nested tables with fixed height -->
<table id="overview_table" cellspacing=0 cellpadding=2 border="0"  >
   <tr>
      <td align="left" valign="top" nowrap>

<script language="JavaScript">
//<!--

	var _canModify = false;
	<c:if test="${empty updateStrategies || updateStrategies || empty updateQueues|| updateQueues}">
	_canModify = true;
	</c:if>
	parent.sas.fscf.getCurrentOverviewToolbar().setContentFor('any', _canModify);

   var MARKS = ["BUSINESSUNIT","STRATEGY","QUEUE"];

   var strategyNodes = new Array();
   var selectedNode = getCookieForTab("BU1");
   var openNode = selectedNode;
   var _isSomethingSelected = false;
   // Business Unit Nodes
   var _businessUnitNodeMap=new Array();
   <c:forEach var="businessUnit" items="${businessUnits}" varStatus="status">

      <c:set var="currentStrategyNodeId" value="BU${sStatus.count}"/>
      var _businessUnit = new Object();
      _businessUnit.id = ${businessUnit.id};
      _businessUnit.name = "${esapi:encodeForJavaScript(esapi:encodeForHTML(businessUnit.name))}";
//      var nodeId = "BU" + "${status.count}";
      var nodeId = "BU" + "${businessUnit.id}";
      _businessUnitNodeMap[_businessUnit.id] = nodeId;

       // A businessUnit has no parent so parent id is 0
       // this is the startnode value when the tree is created
      node = new Node(nodeId, 0, "UserRole", _businessUnit.name,"<esapi:encodeForJavaScript><fmt:message key='fcm.sq.strategy.businessUnit.title.txt'/></esapi:encodeForJavaScript>", new Array("id=${businessUnit.id}"), "", "", "", MARKS[0]);
      strategyNodes.push(node);

   </c:forEach>



	<c:forEach var="strategy" items="${sa_strategies}" varStatus="sStatus">

<%--		<c:set var="currentStrategyNodeId" value="L${sStatus.count}"/> --%>
	<c:set var="currentStrategyNodeId" value="S${strategy.id}"/>

   	node = new Node("${esapi:encodeForJavaScript(currentStrategyNodeId)}",_businessUnitNodeMap['${esapi:encodeForJavaScript(strategy.businessUnit)}'],"folder","${esapi:encodeForJavaScript(esapi:encodeForHTML(strategy.name))}",
                        "<esapi:encodeForJavaScript><fmt:message key='fcm.sq.strategy.strategy.title.txt'/></esapi:encodeForJavaScript>",new Array("<c:url value="#methodName#Strategy.action?"/>","id=${strategy.id}","version=${strategy.version}"),
                        "", "", "", MARKS[1]);
      strategyNodes.push(node);

      <c:if test="${not empty sa_strategyId and strategy.id == sa_strategyId}">
         _isSomethingSelected = true;
        selectedNode = "${esapi:encodeForJavaScript(currentStrategyNodeId)}";
      </c:if>
	   if( selectedNode == "${esapi:encodeForJavaScript(currentStrategyNodeId)}" )
            openNode = _businessUnitNodeMap['${esapi:encodeForJavaScript(strategy.businessUnit)}']+"|"+"${esapi:encodeForJavaScript(currentStrategyNodeId)}";

 //     parent._hasQueues["${esapi:encodeForJavaScript(currentStrategyNodeId)}"] = ${esapi:encodeForJavaScript(fn:length(strategy.queues)) > 0};

      <c:forEach var="queue" items="${strategy.queues}" varStatus="qStatus" >
<%--      	<c:set var="currentQueueNodeId" value="${currentStrategyNodeId}L${qStatus.count}"/> --%>
		<c:set var="currentQueueNodeId" value="Q${queue.id}"/>

      	node = new Node("${esapi:encodeForJavaScript(currentQueueNodeId)}","${esapi:encodeForJavaScript(currentStrategyNodeId)}","template","${esapi:encodeForJavaScript(esapi:encodeForHTML(queue.name))}",
                           "<esapi:encodeForJavaScript><fmt:message key='fcm.sq.strategy.queue.title.txt'/></esapi:encodeForJavaScript>",new Array("<c:url value="#methodName#Queue.action?"/>","id=${queue.id}","version=#version##d#${queue.version}"),
                           "", "", "", MARKS[2]);
         strategyNodes.push(node);

         <c:if test="${not empty qa_queueId and queue.id == qa_queueId}">
           selectedNode = "${esapi:encodeForJavaScript(currentQueueNodeId)}";
           _isSomethingSelected = true;
         </c:if>
         if( selectedNode == "${esapi:encodeForJavaScript(currentQueueNodeId)}" )
            openNode = _businessUnitNodeMap['${esapi:encodeForJavaScript(strategy.businessUnit)}']+"|"+"${esapi:encodeForJavaScript(currentStrategyNodeId)}"+"|"+"${esapi:encodeForJavaScript(currentQueueNodeId)}";

      </c:forEach>

   </c:forEach>

   <%-- function Tree( name, data, start, open, selected, eventHandler,
                   extend, location, enabled, treeImages, nodeImages )--%>

   var strategyTree = new Tree("strategyTree", strategyNodes, 0, openNode, selectedNode,
                                 'doStrategyAction(\'modify\')', false, false, true,
                                 "common/images/tree/", "common/images/" );

   // Generic method defined to show selected node
   Tree.showSelectedAdminNode = function(){ strategyTree.showNode();};

   function getStrategyId(node)
   {
   	if(node)
   	{
			return node.parameters[1].substring(3);
   	}
   	return "";
   }
   function getBusinessUnitId(node)
      {
      	if(node)
      	{
   		return node.parameters[0].substring(3);
      	}
      	return "";
   }

//-->
</script>

 </td>
   </tr>
</table>

<%-- Error handling code --%>
<tiles:insertTemplate template="/admin/adminOverviewErrorHandlingT3.jsp" flush="true">
	<tiles:putAttribute name="treeObj" value="strategyTree" />
	<tiles:putAttribute name="showCommand" value="doStrategyAction" />
	<tiles:putAttribute name="showCommandArgs" value="modify" />
	<tiles:putAttribute name="window" value="window"/>
</tiles:insertTemplate>
